
.data

.data?
hCmbCases		dd ?
caseID			dd ?

.code
CaseFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL hGrid		:DWORD
	LOCAL index		:DWORD
	LOCAL nBooks	:DWORD
	LOCAL nRow		:WORD
	LOCAL hCursor	:DWORD
	push ebx
	push esi
	push edi
	
	ASSUME ebx:PTR BOOKS
;------------------------------------------------------------	
	.if uMsg==WM_INITDIALOG
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		invoke GetDlgItem,hwnd,IDC_GRID_CASES
		mov hGrid,eax
		invoke SendMessage,hGrid,GM_SETCOLS,2,0
		invoke SendMessage,hGrid,GM_SETROWS,2,0
		invoke SendMessage,hGrid,GM_ALLOWEDIT,0,0
		invoke SendMessage,hGrid,GM_ALLOWSELECTION,0,0
		invoke SendMessage,hGrid,GM_SETCOLWIDTH,1,400
		MAKEDWORD 1,0
		push eax
		invoke SendMessage,hGrid,GM_SETCELLALIGN,eax,HORZ_CENTER or VERT_CENTER
		pop edx
		invoke SendMessage,hGrid,GM_SETCELLTEXT,edx,addr szBookName
		;-------------------
		.if numCases==0
			jmp exit
		.endif
		invoke GetDlgItem,hwnd,IDC_COMBO_CASES
		mov hCmbCases,eax
		mov eax,numCases
		lea eax,[eax+eax*2]
		shl eax,4			;eax=size of cases
		invoke SendMessage,hCmbCases,CB_INITSTORAGE,numCases,eax
		ASSUME edi:PTR CASES
		mov edi,pCases
		mov index,0
		LoadCases:
			mov esi,index
			lea esi,[esi+esi*2]
			shl esi,4
			invoke SendMessage,hCmbCases,CB_ADDSTRING,\
									0,addr [edi+esi].szName
			invoke SendMessage,hCmbCases,CB_SETITEMDATA,\
									eax,[edi+esi].ID
			inc index
			mov eax,index
			cmp eax,numCases
			jb LoadCases
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND
		.if numCases==0
			jmp exit
		.endif
		ASSUME edi:PTR CASES
		mov edi,pCases
		invoke GetDlgItem,hwnd,IDC_GRID_CASES
		mov hGrid,eax
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==CBN_EDITUPDATE
			.if ax==IDC_COMBO_CASES
				invoke EmptyBuffer,addr szCase,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_CASES,\
											addr szCase,40
				invoke ltrim,addr szCase,addr szCase
				invoke SendMessage,hCmbCases,CB_FINDSTRINGEXACT,\
											-1,addr szCase
				.if eax !=CB_ERR
					invoke SendMessage,hCmbCases,CB_SELECTSTRING,\
											-1,addr szCase
					invoke SendMessage,hCmbCases,CB_GETITEMDATA,eax,0
					mov caseID,eax
				.else
					jmp exit	
				.endif
			.endif
		;-----------------------------------------
		.elseif dx==CBN_SELENDOK
			.if ax==IDC_COMBO_CASES
				invoke SendMessage,hCmbCases,CB_GETCURSEL,0,0
				invoke SendMessage,hCmbCases,CB_GETITEMDATA,eax,0
				mov caseID,eax
			.endif
		.else
			jmp exit
		.endif
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		xor ecx,ecx
		mov nRow,0
		SearchCase:						
			mov eax,caseID
			mov edx,ecx
			lea edx,[edx+edx*2]
			shl edx,4
			cmp [edi+edx].ID,eax
			je findCase
			inc ecx
			cmp ecx,numCases
			jb SearchCase
		findCase:
			mov eax,[edi+edx].numBooks
			mov nBooks,eax
			.if eax==0
				jmp exit
			.endif
		inc eax
		invoke SendMessage,hGrid,GM_SETROWS,eax,0
		invoke SendMessage,hGrid,GM_COUNTROWS,SORT_ASC\
							,HORZ_CENTER or VERT_CENTER
		xor esi,esi
		mov ebx,pBooks
		SearchBooks:
			mov eax,caseID
			mov edx,esi				;esi=index
			shl edx,6
			cmp [ebx+edx].ID_C,eax	;eax=ID_C
			je findBook
			inc esi				
			cmp esi,numBooks
			jb SearchBooks
		jmp exit		
		findBook:
			inc nRow
			inc esi
			MAKEDWORD 1,nRow
			mov ecx,eax
			invoke SendMessage,hGrid,GM_SETCELLTEXT,ecx,\
								addr [ebx+edx].szTitle
			
			xor eax,eax
			mov ax,nRow
			cmp eax,nBooks
			jbe SearchBooks
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		mov fCaseFormExist,FALSE
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ASSUME ebx:nothing
		ASSUME edi:nothing
		pop edi
		pop esi
		pop ebx
		ret 
	.endif
	exit:
	ASSUME ebx:nothing
	ASSUME edi:nothing
	pop edi
	pop esi
	pop ebx
	xor eax,eax
	ret
CaseFormProc endp
