
.data
szWarning			db "        ?",0
.data?
bookID				dd ?
.code
ChangesFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL index		:DWORD
	LOCAL ID_C		:DWORD
	LOCAL ID_A1		:DWORD
	LOCAL ID_A2		:DWORD
	LOCAL ID_A3		:DWORD
	LOCAL hCursor	:DWORD
	push ebx
	push esi
	push edi
	
	ASSUME ebx:PTR BOOKS
;------------------------------------------------------------	
	.if uMsg==WM_INITDIALOG
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		invoke GetDlgItem,hwnd,IDC_COMBO_CHANGES_TITLE
		mov hCmbChanges,eax
		invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_OK
		invoke EnableWindow,eax,FALSE
		invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_DEL
		invoke EnableWindow,eax,FALSE
		.if numBooks>0
			invoke SendMessage,hCmbChanges,CB_RESETCONTENT,0,0
			mov eax,numBooks
			shl eax,6
			invoke SendMessage,hCmbChanges,CB_INITSTORAGE,numBooks,eax
			mov ebx,pBooks
			mov index,0
			LoadCmbChanges:
				mov esi,index
				shl esi,6
				invoke SendMessage,hCmbChanges,CB_ADDSTRING,\
										0,addr [ebx+esi].szTitle
				invoke SendMessage,hCmbChanges,CB_SETITEMDATA,\
										eax,[ebx+esi].ID
				inc index
				mov eax,index
				cmp eax,numBooks
				jb LoadCmbChanges
		.else		
			invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_DEL
			invoke EnableWindow,eax,FALSE
		.endif
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND	
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
		;------------------------------
			.if ax==IDC_BUTTON_CHANGES_OK
				.if fRectifyFormExist==TRUE
					jmp exit
				.endif
				mov fRectifyForm,TRUE
				invoke SendMessage,hCmbChanges,CB_GETCURSEL,0,0
				invoke SendMessage,hCmbChanges,CB_GETITEMDATA,eax,0
				mov bookID,eax
				
				invoke CreateMDIWindow,addr szChildClass,addr szRectifyFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
		;------------------------------
			.elseif ax==IDC_BUTTON_CHANGES_CANCEL
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				invoke SendMessage,eax,WM_CLOSE,0,0
		;------------------------------
			.elseif ax==IDC_BUTTON_CHANGES_DEL
				invoke MessageBox,hFrame,addr szWarning,\
								addr szAppName,MB_YESNO or\
								MB_ICONWARNING or MB_DEFBUTTON2
				.if eax==IDNO
					jmp exit
				.endif
				invoke LoadCursor,NULL, IDC_WAIT
				invoke SetCursor,eax
				mov hCursor,eax
				invoke EmptyBuffer,addr szTitle,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_CHANGES_TITLE,\
											addr szTitle,40
				invoke SendMessage,hCmbChanges,CB_SELECTSTRING,\
											-1,addr szTitle
				invoke SendMessage,hCmbChanges,CB_GETITEMDATA,eax,0
				
				xor ecx,ecx
				mov ebx,pBooks
				SearchBook:
					mov edx,ecx
					shl edx,6
					cmp [ebx+edx].ID,eax	;eax=bookID
					je findBook
					inc ecx					
					cmp ecx,numBooks
					jb SearchBook
				
				findBook:
					mov eax,[ebx+edx].ID_C
					mov ID_C,eax
					mov eax,[ebx+edx].ID_A1
					mov ID_A1,eax
					mov eax,[ebx+edx].ID_A2
					mov ID_A2,eax
					mov eax,[ebx+edx].ID_A3
					mov ID_A3,eax
				;-----------------
					mov eax,ecx				;ecx=index
					inc eax					;eax=next index
					.if eax==numBooks
						jmp noCopyBook
					.else
						mov edx,numBooks
						sub edx,eax
						shl edx,6			;edx=size
						shl ecx,6			;offset dest
						shl eax,6			;offset source
						add ecx,ebx			;ecx=pDest
						add eax,ebx			;eax=pSourse
						invoke memCopy,ecx,eax,edx
					.endif
					noCopyBook:
					mov fFileChanged,TRUE
					dec numBooks
					mov eax,numBooks
					shl eax,6
					invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
											pBooks,eax
					.if eax==0
						invoke MessageBox,hwnd,addr szMemError,\
		               			addr szAppName,MB_OK or MB_ICONSTOP
						jmp exit
					.endif
					mov pBooks,eax		;eax=new pBooks
				;----------------------	
					ASSUME esi:PTR AUTHORS
					ASSUME edi:PTR CASES
					mov edi,pCases
					xor ecx,ecx
					SearchCase:
						mov eax,ID_C
						mov edx,ecx
						lea edx,[edx+edx*2]
						shl edx,4
						cmp [edi+edx].ID,eax
						je findCase
						inc ecx
						cmp ecx,numCases
						jb SearchCase
					jmp ToAuthor1	
					findCase:
					.if [edi+edx].numBooks>0
						dec [edi+edx].numBooks
					.endif
					.if [edi+edx].numBooks==0
						mov eax,ecx				;ecx=index
						inc eax					;eax=next index
						.if eax==numCases
							jmp noCopyCase
						.else
							mov edx,numCases
							sub edx,eax
							lea edx,[edx+edx*2]
							shl edx,4			;edx=size
							lea ecx,[ecx+ecx*2]
							shl ecx,4			;offset dest
							lea eax,[eax+eax*2]
							shl eax,4			;offset source
							add ecx,edi			;ecx=pDest
							add eax,edi			;eax=pSourse
							invoke memCopy,ecx,eax,edx
						.endif
						noCopyCase:
						dec numCases
						mov eax,numCases
						lea eax,[eax+eax*2]
						shl eax,4
						invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
													pCases,eax
						.if eax==0
							invoke MessageBox,hwnd,addr szMemError,\
		               				addr szAppName,MB_OK or MB_ICONSTOP
							jmp exit
						.endif
						mov pCases,eax		;eax=new pBooks
					.endif
				;----------------------	
					ToAuthor1:	
					mov esi,pAuthors
					xor ecx,ecx
					SearchAuthor1:						
						mov eax,ID_A1
						mov edx,ecx
						lea edx,[edx+edx*2]
						shl edx,4
						cmp [esi+edx].ID,eax
						je findAuthor1
						inc ecx
						cmp ecx,numAuthors
						jb SearchAuthor1
					jmp ToAuthor2
					findAuthor1:
					.if [esi+edx].numBooks>0
						dec [esi+edx].numBooks
					.endif
					.if [esi+edx].numBooks==0
						mov eax,ecx				;ecx=index
						inc eax					;eax=next index
						.if eax==numAuthors
							jmp noCopyAuthor1
						.else
							mov edx,numAuthors
							sub edx,eax
							lea edx,[edx+edx*2]
							shl edx,4			;edx=size
							lea ecx,[ecx+ecx*2]
							shl ecx,4			;offset dest
							lea eax,[eax+eax*2]
							shl eax,4			;offset source
							add ecx,esi			;ecx=pDest
							add eax,esi			;eax=pSourse
							invoke memCopy,ecx,eax,edx
						.endif
						noCopyAuthor1:
						dec numAuthors
						mov eax,numAuthors
						lea eax,[eax+eax*2]
						shl eax,4
						invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
													pAuthors,eax
						.if eax==0
							invoke MessageBox,hwnd,addr szMemError,\
		               				addr szAppName,MB_OK or MB_ICONSTOP
							jmp exit
						.endif
						mov pAuthors,eax		;eax=new pBooks
					.endif
				;----------------------	
					ToAuthor2:	
					mov esi,pAuthors
					xor ecx,ecx
					SearchAuthor2:						
						mov eax,ID_A2
						mov edx,ecx
						lea edx,[edx+edx*2]
						shl edx,4
						cmp [esi+edx].ID,eax
						je findAuthor2
						inc ecx
						cmp ecx,numAuthors
						jb SearchAuthor2
					jmp ToAuthor3
					findAuthor2:
					.if [esi+edx].numBooks>0
						dec [esi+edx].numBooks
					.endif
					.if [esi+edx].numBooks==0
						mov eax,ecx				;ecx=index
						inc eax					;eax=next index
						.if eax==numAuthors
							jmp noCopyAuthor2
						.else
							mov edx,numAuthors
							sub edx,eax
							lea edx,[edx+edx*2]
							shl edx,4			;edx=size
							lea ecx,[ecx+ecx*2]
							shl ecx,4			;offset dest
							lea eax,[eax+eax*2]
							shl eax,4			;offset source
							add ecx,esi			;ecx=pDest
							add eax,esi			;eax=pSourse
							invoke memCopy,ecx,eax,edx
						.endif
						noCopyAuthor2:
						dec numAuthors
						mov eax,numAuthors
						lea eax,[eax+eax*2]
						shl eax,4
						invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
													pAuthors,eax
						.if eax==0
							invoke MessageBox,hwnd,addr szMemError,\
		               				addr szAppName,MB_OK or MB_ICONSTOP
							jmp exit
						.endif
						mov pAuthors,eax		;eax=new pBooks
					.endif
				;----------------------	
					ToAuthor3:
					mov esi,pAuthors
					xor ecx,ecx
					SearchAuthor3:						
						mov eax,ID_A3
						mov edx,ecx
						lea edx,[edx+edx*2]
						shl edx,4
						cmp [esi+edx].ID,eax
						je findAuthor3
						inc ecx
						cmp ecx,numAuthors
						jb SearchAuthor3
					jmp NoAuthor
					findAuthor3:
					.if [esi+edx].numBooks>0
						dec [esi+edx].numBooks
					.endif
					.if [esi+edx].numBooks==0
						mov eax,ecx				;ecx=index
						inc eax					;eax=next index
						.if eax==numAuthors
							jmp noCopyAuthor3
						.else
							mov edx,numAuthors
							sub edx,eax
							lea edx,[edx+edx*2]
							shl edx,4			;edx=size
							lea ecx,[ecx+ecx*2]
							shl ecx,4			;offset dest
							lea eax,[eax+eax*2]
							shl eax,4			;offset source
							add ecx,esi			;ecx=pDest
							add eax,esi			;eax=pSourse
							invoke memCopy,ecx,eax,edx
						.endif
						noCopyAuthor3:
						dec numAuthors
						mov eax,numAuthors
						lea eax,[eax+eax*2]
						shl eax,4
						invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
													pAuthors,eax
						.if eax==0
							invoke MessageBox,hwnd,addr szMemError,\
		               				addr szAppName,MB_OK or MB_ICONSTOP
							jmp exit
						.endif
						mov pAuthors,eax		;eax=new pBooks
					.endif
					NoAuthor:						
					ASSUME esi:nothing
					ASSUME edi:nothing
				;----------------------	
					invoke SendMessage,hToolbar,TB_ENABLEBUTTON,IDM_FILE_SAVE,TRUE
					invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_DEL
					invoke EnableWindow,eax,FALSE
					invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_CANCEL
					invoke EnableWindow,eax,FALSE
					invoke SendMessage,hCmbChanges,CB_RESETCONTENT,0,0
					invoke SetCursor,hCursor
					invoke SendMessage,hwnd,WM_INITDIALOG,0,0
			.endif
		;--------------------------------------	
		.elseif dx==CBN_EDITUPDATE
			.if ax==IDC_COMBO_CHANGES_TITLE
				invoke EmptyBuffer,addr szTitle,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_CHANGES_TITLE,\
											addr szTitle,40
				invoke ltrim,addr szTitle,addr szTitle
				invoke rtrim,addr szTitle,addr szTitle
				invoke SendMessage,hCmbChanges,CB_FINDSTRINGEXACT,\
											-1,addr szTitle
				.if eax !=CB_ERR
					invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_OK
					invoke EnableWindow,eax,TRUE
					invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_DEL
					invoke EnableWindow,eax,TRUE
					invoke SendMessage,hCmbChanges,CB_SELECTSTRING,\
											-1,addr szTitle
				.else	
					invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_OK
					invoke EnableWindow,eax,FALSE
					invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_DEL
					invoke EnableWindow,eax,FALSE
				.endif
			.endif
		.elseif dx==CBN_SELENDOK
			.if ax==IDC_COMBO_CHANGES_TITLE	
				invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_CHANGES_DEL
				invoke EnableWindow,eax,TRUE
			.endif
		.endif	
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		mov fChangesFormExist,FALSE
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ASSUME ebx:nothing
		pop edi
		pop esi
		pop ebx
		ret 
	.endif
	exit:
	ASSUME ebx:nothing
	pop edi
	pop esi
	pop ebx
	xor eax,eax
	ret
ChangesFormProc endp
