
.data

.data?
hCmbTitles			dd ?

.code
TitlesFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL hGrid		:DWORD
	LOCAL rowHeight	:DWORD
	LOCAL index		:DWORD
	LOCAL ID_C		:DWORD
	LOCAL ID_A1		:DWORD
	LOCAL ID_A2		:DWORD
	LOCAL ID_A3		:DWORD
	LOCAL hCursor	:DWORD
	push ebx
	push esi
	push edi
	
	ASSUME ebx:PTR BOOKS
;------------------------------------------------------------	
	.if uMsg==WM_INITDIALOG
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		invoke GetDlgItem,hwnd,IDC_GRID_TITLES
		mov hGrid,eax
		invoke SendMessage,hGrid,GM_SETCOLS,5,0
		invoke SendMessage,hGrid,GM_SETROWS,2,0
		invoke SendMessage,hGrid,GM_ALLOWEDIT,0,0
		invoke SendMessage,hGrid,GM_ALLOWSELECTION,0,0
		
		mov esi,1
		ColWidthLoop:
			invoke SendMessage,hGrid,GM_SETCOLWIDTH,esi,160
			inc esi
			cmp esi,5
			jb ColWidthLoop
		mov esi,1
		CellAlignLoop:	
			MAKEDWORD si,0
			invoke SendMessage,hGrid,GM_SETCELLALIGN,eax,HORZ_CENTER or VERT_CENTER
			inc esi
			cmp esi,5
			jb CellAlignLoop
			
		MAKEDWORD 1,0
		mov edx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,edx,addr szCaseName
		MAKEDWORD 2,0
		mov edx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,edx,addr szAuthorName1
		MAKEDWORD 3,0
		mov edx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,edx,addr szAuthorName2
		MAKEDWORD 4,0
		mov edx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,edx,addr szAuthorName3
		;------------------
		invoke GetDlgItem,hwnd,IDC_COMBO_TITLES
		mov hCmbTitles,eax
		.if numBooks>0
			invoke SendMessage,hCmbTitles,CB_RESETCONTENT,0,0
			mov eax,numBooks
			shl eax,6
			invoke SendMessage,hCmbTitles,CB_INITSTORAGE,numBooks,eax
			mov ebx,pBooks
			mov index,0
			LoadCmbTitles:
				mov esi,index
				shl esi,6
				invoke SendMessage,hCmbTitles,CB_ADDSTRING,\
										0,addr [ebx+esi].szTitle
				invoke SendMessage,hCmbTitles,CB_SETITEMDATA,\
										eax,[ebx+esi].ID
				inc index
				mov eax,index
				cmp eax,numBooks
				jb LoadCmbTitles
		.endif
	invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND
		invoke GetDlgItem,hwnd,IDC_GRID_TITLES
		mov hGrid,eax
		mov eax,wParam
		mov edx,eax
		shr edx,16
		;-----------------------------------------
		.if dx==CBN_EDITUPDATE
			.if ax==IDC_COMBO_TITLES
				invoke EmptyBuffer,addr szTitle,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_TITLES,\
											addr szTitle,40
				invoke ltrim,addr szTitle,addr szTitle
				invoke SendMessage,hCmbTitles,CB_FINDSTRINGEXACT,\
											-1,addr szTitle
				.if eax !=CB_ERR
					invoke SendMessage,hCmbTitles,CB_SELECTSTRING,\
											-1,addr szTitle
					invoke SendMessage,hCmbTitles,CB_GETITEMDATA,eax,0
					mov bookID,eax
				.else
					jmp exit	
				.endif
			.endif
		;-----------------------------------------
		.elseif dx==CBN_SELENDOK
			.if ax==IDC_COMBO_TITLES
				invoke SendMessage,hCmbTitles,CB_GETCURSEL,0,0
				invoke SendMessage,hCmbTitles,CB_GETITEMDATA,eax,0
				mov bookID,eax
			.endif
		.else
			jmp exit
		.endif
		ASSUME esi:PTR AUTHORS
		ASSUME edi:PTR CASES
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		mov eax,bookID
		mov edi,pCases
		mov esi,pAuthors
		xor ecx,ecx
		mov ebx,pBooks
		SearchBook:
			mov edx,ecx				;ecx=index
			shl edx,6
			cmp [ebx+edx].ID,eax	;eax=bookID
			je findBook
			inc ecx					
			cmp ecx,numBooks
			jb SearchBook
				
		findBook:
			mov eax,[ebx+edx].ID_C
			mov ID_C,eax
			mov eax,[ebx+edx].ID_A1
			mov ID_A1,eax
			mov eax,[ebx+edx].ID_A2
			mov ID_A2,eax
			mov eax,[ebx+edx].ID_A3
			mov ID_A3,eax
		invoke SendMessage,hGrid,GM_SETROW,1,0
		invoke SendMessage,hGrid,GM_SETROWSEL,1,0
		invoke SendMessage,hGrid,GM_SETCOL,1,0
		invoke SendMessage,hGrid,GM_SETCOLSEL,4,0
		invoke SendMessage,hGrid,GM_CLEAR,0,0
		xor ecx,ecx
		SearchCase:	
			mov eax,ID_C
			mov edx,ecx
			lea edx,[edx+edx*2]
			shl edx,4
			cmp [edi+edx].ID,eax
			je findCase
			inc ecx
			cmp ecx,numCases
			jb SearchCase
		jmp ToAuthor1	
		findCase:
		MAKEDWORD 1,1
		mov ecx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,ecx,addr [edi+edx].szName
		ToAuthor1:						
		xor ecx,ecx
		SearchAuthor1:						
			mov eax,ID_A1
			mov edx,ecx
			lea edx,[edx+edx*2]
			shl edx,4
			cmp [esi+edx].ID,eax
			je findAuthor1
			inc ecx
			cmp ecx,numAuthors
			jb SearchAuthor1
		jmp ToAuthor2
		findAuthor1:
		MAKEDWORD 2,1
		mov ecx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,ecx,addr [esi+edx].szName
		ToAuthor2:						
		xor ecx,ecx
		SearchAuthor2:						
			mov eax,ID_A2
			mov edx,ecx
			lea edx,[edx+edx*2]
			shl edx,4
			cmp [esi+edx].ID,eax
			je findAuthor2
			inc ecx
			cmp ecx,numAuthors
			jb SearchAuthor2
		jmp ToAuthor3
		findAuthor2:
		MAKEDWORD 3,1
		mov ecx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,ecx,addr [esi+edx].szName
		ToAuthor3:						
		xor ecx,ecx
		SearchAuthor3:						
			mov eax,ID_A3
			mov edx,ecx
			lea edx,[edx+edx*2]
			shl edx,4
			cmp [esi+edx].ID,eax
			je findAuthor3
			inc ecx
			cmp ecx,numAuthors
			jb SearchAuthor3
		jmp NoAuthor
		findAuthor3:
		MAKEDWORD 4,1
		mov ecx,eax
		invoke SendMessage,hGrid,GM_SETCELLTEXT,ecx,addr [esi+edx].szName
		NoAuthor:
		ASSUME esi:nothing
		ASSUME edi:nothing
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		mov fTitlesFormExist,FALSE
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ASSUME ebx:nothing
		pop edi
		pop esi
		pop ebx
		ret 
	.endif
	exit:
	ASSUME ebx:nothing
	pop edi
	pop esi
	pop ebx
	xor eax,eax
	ret
TitlesFormProc endp
