
.data



.data?
hCmbAuthors			dd ?
authorID			dd ?

.code
AuthorsFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL hGrid		:DWORD
	LOCAL rowHeight	:DWORD
	LOCAL index		:DWORD
	LOCAL ID_A1		:DWORD
	LOCAL ID_A2		:DWORD
	LOCAL ID_A3		:DWORD
	LOCAL nBooks	:DWORD
	LOCAL Rows		:DWORD
	LOCAL nRow		:WORD
	LOCAL hCursor	:DWORD
	push ebx
	push esi
	push edi
	
	ASSUME ebx:PTR BOOKS
;------------------------------------------------------------	
	.if uMsg==WM_INITDIALOG
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		invoke GetDlgItem,hwnd,IDC_GRID_AUTHORS
		mov hGrid,eax
		invoke SendMessage,hGrid,GM_SETCOLS,2,0
		invoke SendMessage,hGrid,GM_SETROWS,2,0
		invoke SendMessage,hGrid,GM_ALLOWEDIT,0,0
		invoke SendMessage,hGrid,GM_ALLOWSELECTION,0,0
		invoke SendMessage,hGrid,GM_SETCOLWIDTH,1,400
		MAKEDWORD 1,0
		push eax
		invoke SendMessage,hGrid,GM_SETCELLALIGN,eax,HORZ_CENTER or VERT_CENTER
		pop edx
		invoke SendMessage,hGrid,GM_SETCELLTEXT,edx,addr szBookName
		;-------------------
		.if numAuthors==0
			jmp exit
		.endif
		invoke GetDlgItem,hwnd,IDC_COMBO_AUTHORS
		mov hCmbAuthors,eax
		mov eax,numAuthors
		lea eax,[eax+eax*2]
		shl eax,4			;eax=size of authors
		invoke SendMessage,hCmbAuthors,CB_INITSTORAGE,numAuthors,eax
		ASSUME esi:PTR AUTHORS
		mov esi,pAuthors
		mov index,0
		LoadAuthors:
			mov edi,index
			lea edi,[edi+edi*2]
			shl edi,4
			invoke SendMessage,hCmbAuthors,CB_ADDSTRING,\
									0,addr [esi+edi].szName
			invoke SendMessage,hCmbAuthors,CB_SETITEMDATA,\
									eax,[esi+edi].ID
			inc index
			mov eax,index
			cmp eax,numAuthors
			jb LoadAuthors
		ASSUME esi:nothing
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND
		.if numAuthors==0
			jmp exit
		.endif
		invoke GetDlgItem,hwnd,IDC_GRID_AUTHORS
		mov hGrid,eax
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==CBN_EDITUPDATE
			.if ax==IDC_COMBO_AUTHORS
				invoke EmptyBuffer,addr szAuthor,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_AUTHORS,\
											addr szAuthor,40
				invoke ltrim,addr szAuthor,addr szAuthor
				invoke SendMessage,hCmbAuthors,CB_FINDSTRINGEXACT,\
											-1,addr szAuthor
				.if eax !=CB_ERR
					invoke SendMessage,hCmbAuthors,CB_SELECTSTRING,\
											-1,addr szAuthor
					invoke SendMessage,hCmbAuthors,CB_GETITEMDATA,eax,0
					mov authorID,eax
				.else
					jmp exit	
				.endif
			.endif
		;-----------------------------------------
		.elseif dx==CBN_SELENDOK
			.if ax==IDC_COMBO_AUTHORS
				invoke SendMessage,hCmbAuthors,CB_GETCURSEL,0,0
				invoke SendMessage,hCmbAuthors,CB_GETITEMDATA,eax,0
				mov authorID,eax
			.endif
		.else
			jmp exit
		.endif
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
;		ASSUME edi:PTR CASES
		ASSUME esi:PTR AUTHORS
;		mov edi,pCases
		mov esi,pAuthors
		xor ecx,ecx
		mov nRow,0
		SearchAuthor:						
			mov eax,authorID
			mov edx,ecx
			lea edx,[edx+edx*2]
			shl edx,4
			cmp [esi+edx].ID,eax
			je findAuthor
			inc ecx
			cmp ecx,numAuthors
			jb SearchAuthor
		findAuthor:
			mov eax,[esi+edx].numBooks
			mov nBooks,eax
			.if eax==0
				jmp exit
			.endif
		inc eax
		invoke SendMessage,hGrid,GM_SETROWS,eax,0
		invoke SendMessage,hGrid,GM_COUNTROWS,SORT_ASC\
							,HORZ_CENTER or VERT_CENTER
		ASSUME esi:nothing
		xor esi,esi
		mov ebx,pBooks
		SearchBooks:
			mov eax,authorID
			mov edx,esi				;esi=index
			shl edx,6
			cmp [ebx+edx].ID_A1,eax	;eax=ID_A1
			je findBook
			cmp [ebx+edx].ID_A2,eax	;eax=ID_A2
			je findBook
			cmp [ebx+edx].ID_A3,eax	;eax=ID_A3
			je findBook
			inc esi				
			cmp esi,numBooks
			jb SearchBooks
		jmp exit		
		findBook:
			inc nRow
			inc esi
			MAKEDWORD 1,nRow
			mov ecx,eax
			invoke SendMessage,hGrid,GM_SETCELLTEXT,ecx,\
								addr [ebx+edx].szTitle
			xor eax,eax
			mov ax,nRow
			cmp eax,nBooks
			jbe SearchBooks
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		mov fAuthorsFormExist,FALSE
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ASSUME ebx:nothing
		ASSUME edi:nothing
		pop edi
		pop esi
		pop ebx
		ret 
	.endif
	exit:
	ASSUME ebx:nothing
	ASSUME edi:nothing
	pop edi
	pop esi
	pop ebx
	xor eax,eax
	ret
AuthorsFormProc endp
