.386
.model flat,stdcall
option casemap:none

include Frame.inc


.code
start:
		invoke LoadLibrary,addr szLibName
		mov hLib,eax
		.if eax==0
			invoke MessageBox,NULL,addr szNoLib,addr szAppName,MB_OK or MB_ICONSTOP 
			invoke ExitProcess,0
		.endif
		invoke GetModuleHandle,NULL
		mov hInstance,eax
		invoke InitCommonControls
		invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
	    invoke FreeLibrary,hLib
		invoke ExitProcess,eax
		
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,cmdLine:LPSTR,cmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	
	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,0
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,NULL
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_APPWORKSPACE+1
	mov		wc.lpszMenuName,IDR_FIRSTMENU
	mov		wc.lpszClassName,OFFSET szClassName
	invoke LoadIcon,hInst,IDB_ICON
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET ChildProc
	mov		wc.cbWndExtra,4
	mov		wc.hbrBackground,0
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szChildClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET MainFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szMainFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET TitlesFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szTitlesFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET AuthorsFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szAuthorsFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET CaseFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szCaseFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET RegFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szRegFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET ChangesFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szChangesFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	mov		wc.lpfnWndProc,OFFSET RectifyFormProc
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_CHILDMENU
	mov		wc.lpszClassName,OFFSET szRectifyFormClass
	invoke RegisterClassEx,addr wc
;-------------------------------------------------	
	invoke CreateWindowEx,NULL,addr szClassName,addr szAppName,\
					WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
					CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
					CW_USEDEFAULT,NULL,0,hInst,NULL	
	mov hFrame,eax
	invoke LoadMenu,hInst,IDR_MAINMENU
	mov hMainMenu,eax
	invoke LoadMenu,hInst,IDR_CHILDMENU
	mov hChildMenu,eax
	invoke ShowWindow,hFrame,SW_MAXIMIZE
	invoke UpdateWindow,hFrame
	.while TRUE
			invoke GetMessage,addr msg,NULL,0,0
	  		.break .if !eax
			invoke TranslateMDISysAccel,hClient,addr msg
			.if !eax
				invoke TranslateMessage,addr msg
				invoke DispatchMessage,addr msg
			.endif
	.endw
	invoke DestroyMenu,hMainMenu
	invoke DestroyMenu,hChildMenu
	mov	eax,msg.wParam

	ret
WinMain endp
WndProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL clientStrc	:CLIENTCREATESTRUCT
	LOCAL rcClFrame		:RECT
	LOCAL rcTlbar		:RECT
	LOCAL rcStatus		:RECT
	LOCAL ptTlbar		:POINT
	LOCAL ptStatus		:POINT
	LOCAL hdc			:DWORD
	LOCAL hChild		:DWORD
	.if uMsg==WM_CREATE
		invoke GetMenu,hWnd
		mov hFirstMenu,eax
		invoke GetSubMenu,hFirstMenu,2
		mov clientStrc.hWindowMenu,eax
		mov clientStrc.idFirstChild,401
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr szClientName,NULL,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						MDIS_ALLCHILDSTYLES ,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
						hWnd,NULL,hInstance,addr clientStrc
		mov hClient,eax
		
		invoke CreateToolbarEx, hWnd, WS_CHILD or \
					WS_CLIPCHILDREN or WS_CLIPSIBLINGS or \
					TBSTYLE_TOOLTIPS or CCS_TOP,ID_TOOLBAR, \
					1, hInstance,IDB_TOOLBAR, \
					addr tbb,12, 16, 16, 16, 16, sizeof TBBUTTON
		mov hToolbar,eax
	;	push edi
	;	mov edi,203
	;	TbrLoop1:
	;		invoke SendMessage,hToolbar,TB_ENABLEBUTTON,edi,FALSE
	;		inc edi
	;		cmp edi,224
	;		jbe TbrLoop1
	;	pop edi
    	invoke SendMessage,hToolbar,TB_SETSTYLE,0,TBSTYLE_FLAT or CCS_TOP
    	invoke ShowWindow,hToolbar,TRUE
		invoke CreateStatus,hWnd
        invoke CreateFont,14,0,0,0,400,0,0,0,ANSI_CHARSET,\ 
                             OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,\ 
                             DEFAULT_QUALITY,DEFAULT_PITCH or FF_SCRIPT,\ 
                             addr szFontName
        mov hFont,eax
        
		mov ofn.lStructSize,sizeof OPENFILENAME
		mov eax,hWnd
		mov ofn.hwndOwner,eax
		mov ofn.lpstrFilter,offset szFileFilter
		mov ofn.nMaxFile,256
		mov eax,hInstance
		mov ofn.hInstance,eax
		mov ofn.lpstrDefExt,offset szFileEx
		mov ofn.lCustData,0
		mov ofn.lpfnHook,0
		mov ofn.lpstrCustomFilter,0
		mov ofn.lpstrInitialDir,0
		mov ofn.lpstrTitle,0
		mov ofn.lpTemplateName,0
		mov ofn.nFileOffset,0
		mov ofn.nFilterIndex,0
		mov ofn.nMaxCustFilter,0
		mov ofn.nMaxFileTitle,64
		mov ofn.nFileExtension,0
;---------------------------------------------------------------
	.elseif uMsg==WM_INITMENUPOPUP
		mov eax,lParam
		.if ax==0		; file menu			
			.if fFileChanged==TRUE	
				invoke EnableMenuItem,wParam,IDM_FILE_SAVE,MF_ENABLED
			.else
				invoke EnableMenuItem,wParam,IDM_FILE_SAVE,MF_GRAYED
			.endif
		.endif	
;---------------------------------------------------------------
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==IDM_FILE_EXIT
			invoke SendMessage,hWnd,WM_CLOSE,0,0
		.elseif ax==IDM_WIN_TILEHORZ
			invoke SendMessage,hClient,WM_MDITILE,MDITILE_HORIZONTAL,0 
		.elseif ax==IDM_WIN_TILEVERT
			invoke SendMessage,hClient,WM_MDITILE,MDITILE_VERTICAL,0
		.elseif ax==IDM_WIN_CASCADE
			invoke SendMessage,hClient,WM_MDICASCADE,MDITILE_SKIPDISABLED,0
	;--------------------------------------------------------		
		.elseif ax==IDM_FILE_NEW
			.if fFileOpen
				.if fFileChanged
					invoke MessageBox,hWnd,addr szClosePrompt,\
								addr szAppName,MB_YESNO or\
								MB_ICONQUESTION 
					.if eax==IDYES
						invoke lstrcmpi,addr szFileName,addr szZerro
						.if eax==0
							invoke SendMessage,hWnd,WM_COMMAND,\
											IDM_FILE_SAVEAS,0
						.else
							invoke SendMessage,hWnd,WM_COMMAND,\
											IDM_FILE_SAVE,0
						.endif
					.endif
					.if hHeap
						invoke HeapDestroy,hHeap
						invoke HeapCreate,0,1024,0
						mov hHeap,eax
					.endif
				.endif
			.else
				invoke HeapCreate,0,1024,0
				mov hHeap,eax
				;----------------
			.endif
			push edi
			NewLoop:
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				mov edi,eax
				.if edi
					invoke SendMessage,hClient,WM_MDIDESTROY,edi,0
					jne NewLoop
				.endif 
			pop edi
			invoke OnNewFile,hWnd,0
			mov fFileOpen,TRUE
			mov fFileChanged,TRUE
		invoke GetSubMenu,hMainMenu,2
		invoke SendMessage,hClient,WM_MDISETMENU,hMainMenu,eax
		invoke DrawMenuBar,hFrame 
	;--------------------------------------------------------		
		.elseif ax==IDM_FILE_OPEN
			.if fFileOpen
				.if fFileChanged
					invoke MessageBox,hWnd,addr szClosePrompt,\
								addr szAppName,MB_YESNO or\
								MB_ICONQUESTION 
					.if eax==IDYES
						invoke lstrcmpi,addr szFileName,addr szZerro
						.if eax==0
							invoke SendMessage,hWnd,WM_COMMAND,\
											IDM_FILE_SAVEAS,0
						.else
							invoke SendMessage,hWnd,WM_COMMAND,\
											IDM_FILE_SAVE,0
						.endif
					.endif
					.if hHeap
						invoke HeapDestroy,hHeap
						invoke HeapCreate,0,1024,0
						mov hHeap,eax
					.endif
				.endif
			.else
				invoke HeapCreate,0,1024,0
				mov hHeap,eax
			.endif
			push edi
			OpenLoop:
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				mov edi,eax
				.if edi
					invoke SendMessage,hClient,WM_MDIDESTROY,edi,0
					jne OpenLoop
				.endif
			pop edi
			invoke EmptyBuffer,addr szFileName,256
			mov ofn.lpstrFile,offset szFileName
			mov ofn.Flags,OFN_FILEMUSTEXIST
			mov ofn.lpstrFileTitle,offset szFileTitle
			
			invoke GetOpenFileName,addr ofn
			.if eax
				invoke OnOpenFile,hWnd,addr szFileName
			.endif
			mov fFileOpen,TRUE
			invoke GetSubMenu,hMainMenu,2
			invoke SendMessage,hClient,WM_MDISETMENU,hMainMenu,eax
			invoke DrawMenuBar,hFrame 
	;--------------------------------------------------------		
		.elseif ax==IDM_FILE_SAVE
			invoke OnSaveFile,hWnd,addr szFileName
			mov fFileChanged,FALSE
	;--------------------------------------------------------
		.elseif ax==IDM_FILE_SAVEAS
			invoke EmptyBuffer,addr szFileName,256
			mov ofn.lpstrFile,offset szFileName
			mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_OVERWRITEPROMPT
			mov ofn.lpstrFileTitle,offset szFileTitle
			
			invoke GetSaveFileName,addr ofn
			.if eax
				invoke OnSaveFile,hWnd,addr szFileName
			.endif
			
			mov fFileChanged,FALSE
	;--------------------------------------------------------		
		.elseif ax==IDM_FILE_CLOSE
			.if fFileChanged
				invoke MessageBox,hWnd,addr szClosePrompt,\
								addr szAppName,MB_YESNO or\
								MB_ICONQUESTION 
				.if eax==IDYES
					invoke lstrcmpi,addr szFileName,addr szZerro
					.if eax==0
						invoke SendMessage,hWnd,WM_COMMAND,\
										IDM_FILE_SAVEAS,0
					.else
						invoke SendMessage,hWnd,WM_COMMAND,\
										IDM_FILE_SAVE,0
					.endif
				.endif
			.endif
			push edi
			CloseLoop:
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				mov edi,eax
				.if edi
					invoke SendMessage,hClient,WM_MDIDESTROY,edi,0
					jne CloseLoop
				.endif 
			pop edi
			.if hHeap
				invoke HeapDestroy,hHeap	
			.endif	
			mov fFileOpen,FALSE
			mov fFileChanged,FALSE
			.if hHeap
				invoke HeapDestroy,hHeap	
			.endif
			invoke GetSubMenu,hFirstMenu,1
			invoke SendMessage,hClient,WM_MDISETMENU,hFirstMenu,eax
			invoke DrawMenuBar,hFrame 
	;--------------------------------------------------------		
		.elseif ax==IDM_EDIT_CUT
		
	;--------------------------------------------------------		
		.elseif ax==IDM_EDIT_COPY
	
	;--------------------------------------------------------		
		.elseif ax==IDM_EDIT_PASTE
	
	;--------------------------------------------------------
		.elseif ax==IDM_VIEW_SELECTIONS
			mov fMainForm,TRUE
			invoke CreateMDIWindow,addr szChildClass,addr szMainFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
	;--------------------------------------------------------
		.elseif ax==IDM_HELP_CONTENTS	
			invoke WinHelp,hWnd,addr szHelp,HELP_FINDER,0
	;--------------------------------------------------------
		.elseif ax==IDM_HELP_ABOUT
			invoke DialogBoxParam,hInstance, addr szAboutDlg,hWnd,offset AboutDlgProc,NULL
	;--------------------------------------------------------		
		.else
			invoke DefFrameProc,hWnd,hClient,uMsg,wParam,lParam	
			ret
		.endif
;---------------------------------------------------------------			
	.elseif uMsg==WM_SIZE
		.if hClient!=NULL
			invoke GetClientRect,hWnd,addr rcClFrame
			invoke SendMessage,hToolbar,TB_AUTOSIZE,0,0
			invoke MoveWindow,hStatus,0,0,0,0,TRUE
			invoke GetWindowRect,hToolbar,addr rcTlbar
			invoke GetWindowRect,hStatus,addr rcStatus
			mov ptStatus.x,0
			mov ptTlbar.x,0
			push rcStatus.top
			pop ptStatus.y
			invoke ScreenToClient,hWnd,addr ptStatus
			push rcTlbar.bottom
			pop ptTlbar.y
			invoke ScreenToClient,hWnd,addr ptTlbar
			mov eax,ptStatus.y
			sub eax,ptTlbar.y             ;eax=MDIClient height
			mov edx,eax
			invoke MoveWindow,hClient,0,ptTlbar.y,\
								rcClFrame.right,edx,TRUE
		.endif
;---------------------------------------------------------------			
	.elseif uMsg==WM_CLOSE
		.if fFileChanged
			invoke MessageBox,hWnd,addr szClosePrompt,\
							addr szAppName,MB_YESNO or\
							MB_ICONQUESTION 
			.if eax==IDYES
				invoke lstrcmpi,addr szFileName,addr szZerro
				.if eax==0
					invoke SendMessage,hWnd,WM_COMMAND,\
									IDM_FILE_SAVEAS,0
				.else
					invoke SendMessage,hWnd,WM_COMMAND,\
									IDM_FILE_SAVE,0
				.endif
			.endif
		.endif
		.if hHeap
			invoke HeapDestroy,hHeap	
		.endif	
		invoke DestroyWindow,hWnd	
;---------------------------------------------------------------			
	.elseif uMsg==WM_DESTROY
		invoke DeleteObject,hFont
		invoke WinHelp,hWnd,addr szHelp,HELP_QUIT,0
		invoke PostQuitMessage,NULL		
;---------------------------------------------------------------			
	.else
		invoke DefFrameProc,hWnd,hClient,uMsg,wParam,lParam		
		ret
	.endif
	exit:
	xor eax,eax
	ret
WndProc endp
ChildProc proc hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL hDlg			:DWORD
	LOCAL nWidth		:DWORD
	LOCAL nHeight		:DWORD
	LOCAL rc			:RECT
	
	.if uMsg==WM_MDIACTIVATE
		mov eax,lParam
		.if eax==hwnd
			invoke GetSubMenu,hChildMenu,3
			mov edx,eax
			invoke SendMessage,hClient,WM_MDISETMENU,hChildMenu,edx
		.else
			invoke GetSubMenu,hMainMenu,3
			mov edx,eax 
			invoke SendMessage,hClient,WM_MDISETMENU,hMainMenu,edx 
		.endif
		invoke DrawMenuBar,hFrame 
;------------------------------------------------------------	
	.elseif uMsg==WM_CREATE
		.if fMainForm==TRUE
			invoke CreateDialogParam,hInstance,addr szMainForm,\
								hwnd,addr MainFormProc,NULL
			invoke SetWindowLong,hwnd,0,eax
			mov fMainForm,FALSE
		.elseif fRegForm==TRUE
			invoke CreateDialogParam,hInstance,addr szRegForm,\
								hwnd,addr RegFormProc,NULL
			invoke SetWindowLong,hwnd,0,eax
			mov fRegForm,FALSE
			mov fRegFormExist,TRUE
		.elseif fChangesForm==TRUE
			invoke CreateDialogParam,hInstance,addr szChangesForm,\
								hwnd,addr ChangesFormProc,NULL
			mov hChangesForm,eax					
			invoke SetWindowLong,hwnd,0,eax
			mov fChangesForm,FALSE
			mov fChangesFormExist,TRUE
		.elseif fTitlesForm==TRUE
			invoke CreateDialogParam,hInstance,addr szTitlesForm,\
								hwnd,addr TitlesFormProc,NULL
			invoke SetWindowLong,hwnd,0,eax
			mov fTitlesForm,FALSE
			mov fTitlesFormExist,TRUE
		.elseif fAuthorsForm==TRUE
			invoke CreateDialogParam,hInstance,addr szAuthorsForm,\
								hwnd,addr AuthorsFormProc,NULL
			invoke SetWindowLong,hwnd,0,eax
			mov fAuthorsForm,FALSE
			mov fAuthorsFormExist,TRUE
		.elseif fCaseForm==TRUE
			invoke CreateDialogParam,hInstance,addr szCaseForm,\
								hwnd,addr CaseFormProc,NULL
			invoke SetWindowLong,hwnd,0,eax
			mov fCaseForm,FALSE
			mov fCaseFormExist,TRUE
		.elseif fRectifyForm==TRUE
			invoke CreateDialogParam,hInstance,addr szRectifyForm,\
								hwnd,addr RectifyFormProc,NULL
			invoke SetWindowLong,hwnd,0,eax
			mov fRectifyForm,FALSE
			mov fRectifyFormExist,TRUE
		.endif	
;-----------------------------------------------------------------
	.elseif uMsg==WM_SIZE
		mov nWidth,0
		mov nHeight,0
		LOWORD lParam
		mov nWidth,eax
		HIWORD lParam
		mov nHeight,eax
		invoke GetWindowLong,hwnd,0 
		invoke MoveWindow,eax,0,0,nWidth,nHeight,TRUE
		invoke DefMDIChildProc,hwnd,uMsg,wParam,lParam 
		ret 
;-----------------------------------------------------------------
	.elseif uMsg==WM_CLOSE
			invoke SendMessage,hClient,WM_MDIDESTROY,hwnd,0 
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
	      
;-----------------------------------------------------------------
	.else 	
		invoke DefMDIChildProc,hwnd,uMsg,wParam,lParam 
		ret 
	.endif
	exit:
	xor eax,eax
	ret
ChildProc endp
AboutDlgProc proc hWin:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
	.if iMsg==WM_INITDIALOG
		
	.elseif iMsg==WM_CLOSE
		invoke EndDialog,hWin,NULL
	.elseif iMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			.if eax==IDC_BTN_OK_ABOUT
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov  eax,TRUE
	ret
AboutDlgProc endp

include Functions.asm
include Main.asm
include Rectify.asm
include Register.asm
include Titles.asm
include Changes.asm
include Cases.asm
include Authors.asm

end start



