include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\shell32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include Grid.inc
include \masm32\include\debug.inc	

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib GenericGrid.lib
includelib \masm32\lib\debug.lib

WinMain					PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc					PROTO :HWND,:DWORD,:WPARAM,:LPARAM
ChildProc				PROTO :HWND,:DWORD,:WPARAM,:WPARAM
CreateStatus        	PROTO :DWORD
AboutDlgProc			PROTO :HWND,:DWORD,:WPARAM,:LPARAM
MainFormProc			PROTO :HWND,:DWORD,:WPARAM,:WPARAM
TitlesFormProc			PROTO :HWND,:DWORD,:WPARAM,:WPARAM
AuthorsFormProc			PROTO :HWND,:DWORD,:WPARAM,:WPARAM
CaseFormProc			PROTO :HWND,:DWORD,:WPARAM,:WPARAM
RegFormProc				PROTO :HWND,:DWORD,:WPARAM,:WPARAM
RectifyFormProc			PROTO :HWND,:DWORD,:WPARAM,:WPARAM
ChangesFormProc			PROTO :HWND,:DWORD,:WPARAM,:WPARAM
EmptyBuffer         	PROTO :DWORD,:DWORD
OnNewFile				PROTO :HWND,:DWORD
OnOpenFile				PROTO :HWND,:DWORD
OnSaveFile				PROTO :HWND,:DWORD
lnString				PROTO :DWORD
strCopy             	PROTO :DWORD,:DWORD
memCopy					PROTO :DWORD,:DWORD,:DWORD
RemoveAuBook			PROTO :HWND,:DWORD
SetAuthor				PROTO :DWORD
AddAuthor				PROTO :HWND,:LPSTR,:DWORD

.const
IDB_TOOLBAR					equ 51
IDB_ICON					equ 52
IDB_BITMAP					equ 53
IDR_FIRSTMENU				equ 100
IDR_MAINMENU				equ	101
IDR_CHILDMENU				equ	102

IDM_FILE_NEW				equ 200
IDM_FILE_EXIT 				equ 201
IDM_FILE_CLOSE				equ 202
IDM_FILE_SAVEAS				equ 203
IDM_FILE_MRU				equ 204
IDM_FILE_OPEN				equ 205
IDM_FILE_SETUP				equ 206
IDM_FILE_SAVE				equ 207
IDM_FILE_PREVIEW			equ 208
IDM_FILE_PRINT				equ 209
IDM_EDIT_CUT				equ 210
IDM_EDIT_COPY				equ 211
IDM_EDIT_PASTE				equ 212
IDM_VIEW_SELECTIONS			equ 213
IDM_WIN_TILEHORZ			equ 214
IDM_WIN_TILEVERT			equ 215
IDM_WIN_CASCADE				equ 216
IDM_HELP_CONTENTS			equ 217
IDM_HELP_ABOUT				equ 218

IDC_BTN_OK_ABOUT			equ 1001

IDC_PICTURE_MAIN			equ 1002
IDC_BUTTON_MAIN_REG			equ 1003
IDC_BUTTON_MAIN_CHANGES		equ 1004
IDC_BUTTON_MAIN_TITLE		equ 1005
IDC_BUTTON_MAIN_AUTHOR		equ 1006
IDC_BUTTON_MAIN_CASE		equ 1007
IDC_BUTTON_MAIN_EXIT		equ 1008

IDC_COMBO_TITLES			equ 109
IDC_GRID_TITLES				equ 1010
IDC_COMBO_AUTHORS			equ 1011
IDC_GRID_AUTHORS			equ 1012
IDC_COMBO_CASES				equ 1013
IDC_GRID_CASES				equ 1014

IDC_EDIT_REG_TITLE			equ 1015
IDC_EDIT_REG_AUTHOR1		equ 1016
IDC_EDIT_REG_AUTHOR2		equ 1017
IDC_EDIT_REG_AUTHOR3		equ 1018
IDC_COMBO_REG_CASE			equ 1019
IDC_LIST_REG_AUTHOR			equ 1020

IDC_BUTTON_REG_NEWREG		equ 1021
IDC_BUTTON_REG_APPLY		equ 1022
IDC_BUTTON_REG_OK			equ 1023
IDC_BUTTON_REG_CANCEL		equ 1024

IDC_COMBO_CHANGES_TITLE		equ 1025
IDC_BUTTON_CHANGES_OK		equ 1026
IDC_BUTTON_CHANGES_CANCEL	equ 1027
IDC_BUTTON_CHANGES_DEL		equ 1028

IDC_EDIT_RECT_TITLE			equ 1029
IDC_COMBO_RECT_CASE			equ 1030
IDC_EDIT_RECT_AUTHOR1		equ 1031
IDC_EDIT_RECT_AUTHOR2		equ 1032
IDC_EDIT_RECT_AUTHOR3		equ 1033
IDC_LIST_RECT_AUTHOR		equ 1034

IDC_BUTTON_RECT_OK			equ 1035
IDC_BUTTON_RECT_CANCEL		equ 1036

IDC_STATIC1					equ 1037
IDC_STATIC2					equ 1038
IDC_STATIC3					equ 1039	
IDC_STATIC4					equ 1040	
IDC_STATIC5					equ 1041	
IDC_STATIC6					equ 1042
IDC_STATIC7					equ 1043
IDC_STATIC8					equ 1044	
IDC_STATIC9					equ 1045	
IDC_STATIC10				equ 1046	
IDC_STATIC11				equ 1047	
IDC_STATIC12				equ 1048
IDC_STATIC13				equ 1049	
IDC_STATIC14				equ 1050
IDC_STATIC15				equ 1051
IDC_STATIC16				equ 1052
IDC_STATIC17				equ 1053
IDC_STATIC18				equ 1054
IDC_STATIC19				equ 1055
IDC_STATIC20				equ 1056
IDC_STATIC21				equ 1057
IDC_STATIC22				equ 1058
IDC_STATIC23				equ 1059
IDC_STATIC24				equ 1060
IDC_STATIC25				equ 1061

ID_TOOLBAR					equ 250

.data
szClassName				db "CollectionsClass",0
szClientName			db "MDICLIENT",0
szChildClass			db "ChildClass",0
szChildTitle			db "Main Form",0
szAppName				db "BooksCollection",0

szMainForm				db "MainForm",0
szMainFormClass			db "MainFormClass",0
szMainFormName			db "Main Selection Form",0
szRegForm				db "RegForm",0
szRegFormClass			db "RegFormClass",0
szRegFormName			db "Books Registrations",0
szChangesForm			db "ChangesForm",0
szChangesFormClass		db "ChangesFormClass",0
szChangesFormName		db "Modifications",0
szTitlesForm			db "TitlesForm",0
szTitlesFormClass		db "TitlesFormClass",0
szTitlesFormName		db "View by Title",0
szAuthorsForm			db "AuthorsForm",0
szAuthorsFormClass		db "AuthorsFormClass",0
szAuthorsFormName		db "View by Athor",0
szCaseForm				db "CaseForm",0
szCaseFormClass			db "CaseFormClass",0
szCaseFormName			db "View by Case",0
szRectifyForm			db "RectifyForm",0
szRectifyFormClass		db "RectifyFormClass",0
szRectifyFormName		db "Modifications",0
szLibName           	db "GenericGrid.dll",0
szGridClass          	db "GENERIC_GRID",0
szFontName          	db "MS Sans Serif",0
szHelp					db "Collections.hlp",0
szClosePrompt			db "Do you wand to save the changes ?",0
tbClass             	db "ToolbarWindow32",0
szAboutDlg				db 'AboutDlg',0
szNoLib					db "GenericGrid.dll does not found !",0
szFileEx				db ".bks",0
szFileFilter			db "All BooksCollection files ",0,"*.bks",0;,0
szFileID				db "BooksCollection",0
szAuthorName1			db "First Author",0
szAuthorName2			db "Second Author",0
szAuthorName3			db "Third Author",0
szCaseName				db "Book Case",0
szListClass				db "LISTBOX",0
szBookName				db "Book Title",0
szTitleError			db "You have not write Book Title!",0
szCaseError				db "You have not write Book Case!",0
szAuthorError			db "You can not delete Authors!",0
szZerro					db 0
hHeap					dd 0
fMainForm				dd 0
fRegForm				dd 0
fChangesForm			dd 0
fTitlesForm				dd 0
fAuthorsForm			dd 0
fCaseForm				dd 0
fRectifyForm			dd 0
fFileOpen				dd 0
fFileChanged			dd 0
numBooks				dd 0
numAuthors				dd 0
numCases				dd 0
fRegFormExist			dd 0
fChangesFormExist		dd 0
fTitlesFormExist		dd 0
fAuthorsFormExist		dd 0
fCaseFormExist			dd 0
fRectifyFormExist		dd 0
fEditChanged			dd 0

tbb		TBBUTTON <0, IDM_FILE_NEW,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <1, IDM_FILE_OPEN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <2, IDM_FILE_SAVE,0,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <0, 0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0,0>
		TBBUTTON <3, IDM_FILE_PREVIEW,0,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <4, IDM_FILE_PRINT,0,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <0, 0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0,0>
		TBBUTTON <5, IDM_EDIT_CUT,0,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <6, IDM_EDIT_COPY,0,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <7, IDM_EDIT_PASTE,0,TBSTYLE_BUTTON,0,0,0>
		TBBUTTON <0, 0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0,0>
		TBBUTTON <8,IDM_HELP_ABOUT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>

BOOKS			struct	;64 Bytes
	ID			DWORD 0
	szTitle		BYTE 40 dup (0)	
	numAuthors	DWORD 0
	ID_C		DWORD 0	
	ID_A1		DWORD 0
	ID_A2		DWORD 0
	ID_A3		DWORD 0
BOOKS			ends
AUTHORS			struct	;48 Bytes
	ID			DWORD 0
	numBooks	DWORD 0
	szName		BYTE 40 dup (0)	
AUTHORS			ends
CASES			struct	;48 Bytes
	ID			DWORD 0
	numBooks	DWORD 0
	szName		BYTE 40 dup (0)	
CASES			ends

.data?
hInstance			dd ?
hFirstMenu			dd ?
hMainMenu			dd ?
hChildMenu			dd ?
hClient				dd ?
hFrame				dd ?
hChangesForm		dd ?
hStatus             dd ?
hToolbar            dd ?
hLib				dd ?
hFont				dd ?
hBmp				dd ?
pBooks             	dd ?
pAuthors            dd ?
pCases             	dd ?
authorIndex			dd ?
szTitle				db 40 dup (?)
szCase				db 40 dup (?)
szAuthor			db 40 dup (?)
szAuthor1			db 40 dup (?)
szAuthor2			db 40 dup (?)
szAuthor3			db 40 dup (?)
fAllowReg			dd ?
bookOffset			dd ?
hCmbChanges			dd ?
pd					PRINTDLG <?>
ofn					OPENFILENAME <?>
szFileName			db 256 dup (?)
szFileTitle			db 64 dup (?)
RGB MACRO red, green, blue
    xor eax, eax
    mov al, blue    ; blue
    rol eax, 8
    mov al, green   ; green
    rol eax, 8
    mov al, red     ; red
ENDM
MAKEDWORD MACRO LoWord,HiWord
          mov ax, HiWord
          ror eax, 16
          mov ax, LoWord
ENDM
LOWORD MACRO bigword  
       mov  eax,bigword
       and  eax,0FFFFh      
ENDM
HIWORD MACRO bigword  
       mov  eax,bigword
       shr  eax,16
ENDM       
