
.data?

.data
szFontEffect			db "Times New Roman",0
szEffectName			db "BooksCollection",0

.code
CreateStatus proc hParent:DWORD
	
    LOCAL sbParts[4] :DWORD

    invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or \
                              SBS_SIZEGRIP,NULL, hParent, 200
    mov hStatus, eax
      
  ; -------------------------------------
  ; sbParts is a DWORD array of 4 members
  ; -------------------------------------
    mov [sbParts +  0], 120
    mov [sbParts +  4], 240
    mov [sbParts +  8], 360
    mov [sbParts + 12], -1

    invoke SendMessage,hStatus,SB_SETPARTS, 4,ADDR sbParts

    ret

CreateStatus endp
MainFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL hDlg			:DWORD
	LOCAL hdc			:DWORD
	LOCAL ps			:PAINTSTRUCT
	LOCAL hFontEffect	:DWORD
	LOCAL oldFont		:DWORD
	LOCAL rc			:RECT
;------------------------------------------------------------	
	.if uMsg==WM_INITDIALOG
		invoke LoadBitmap,hInstance,IDB_BITMAP
		mov hBmp,eax
		invoke GetDlgItem,hwnd,IDC_PICTURE_MAIN
		invoke SendMessage,eax,STM_SETIMAGE,IMAGE_BITMAP,hBmp
		invoke GetSubMenu,hChildMenu,2
		invoke EnableMenuItem,eax,IDM_VIEW_SELECTIONS,MF_GRAYED
		
		
;------------------------------------------------------------	
	.elseif uMsg==WM_PAINT		
		invoke BeginPaint,hwnd,addr ps
		mov hdc,eax
		invoke GetClientRect,hwnd,addr rc
		invoke SetBkMode,hdc,TRANSPARENT
        invoke CreateFont,64,0,0,0,700,TRUE,0,0,GREEK_CHARSET,\ 
                             OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,\ 
                             DEFAULT_QUALITY,DEFAULT_PITCH or FF_SCRIPT,\ 
                             addr szFontEffect
		mov hFontEffect,eax
		invoke SelectObject,hdc,eax
		mov oldFont,eax
		invoke SetTextColor,hdc,0FF0000h
		invoke TextOut,hdc,10,10,addr szEffectName,15
		
		invoke SelectObject,hdc,oldFont
		invoke DeleteObject,hFontEffect
		invoke EndPaint,hwnd,addr ps
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND	
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			.if ax==IDC_BUTTON_MAIN_REG
				.if fRegFormExist==TRUE
					jmp exit
				.endif
				mov fRegForm,TRUE
				invoke CreateMDIWindow,addr szChildClass,addr szRegFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
			.elseif ax==IDC_BUTTON_MAIN_CHANGES
				.if fChangesFormExist==TRUE
					jmp exit
				.endif
				mov fChangesForm,TRUE
				invoke CreateMDIWindow,addr szChildClass,addr szChangesFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
			.elseif ax==IDC_BUTTON_MAIN_TITLE
				.if fTitlesFormExist==TRUE
					jmp exit
				.endif
				mov fTitlesForm,TRUE
				invoke CreateMDIWindow,addr szChildClass,addr szTitlesFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
			.elseif ax==IDC_BUTTON_MAIN_AUTHOR
				.if fAuthorsFormExist==TRUE
					jmp exit
				.endif
				mov fAuthorsForm,TRUE
				invoke CreateMDIWindow,addr szChildClass,addr szAuthorsFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
			.elseif ax==IDC_BUTTON_MAIN_CASE
				.if fCaseFormExist==TRUE
					jmp exit
				.endif
				mov fCaseForm,TRUE
				invoke CreateMDIWindow,addr szChildClass,addr szCaseFormName,\
						WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or\
						WS_SYSMENU or WS_CAPTION or WS_THICKFRAME or\
						WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,\
						CW_USEDEFAULT,CW_USEDEFAULT,\
						hClient,hInstance,NULL
			.elseif ax==IDC_BUTTON_MAIN_EXIT
				invoke SendMessage,hFrame,WM_CLOSE,0,0
			.endif
		.endif	
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
	    invoke DeleteObject,hBmp  
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ret 
	.endif
	exit:
	xor eax,eax
	ret
MainFormProc endp
