
.data

.data?
hCmbRect			dd ?
hListRect			dd ?
.code
RectifyFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL index		:DWORD
	LOCAL ID_C		:DWORD
	LOCAL ID_A1		:DWORD
	LOCAL ID_A2		:DWORD
	LOCAL ID_A3		:DWORD
	LOCAL hCursor	:DWORD
	LOCAL ID		:DWORD
	LOCAL newID		:DWORD
	
	push ebx
	push esi
	push edi
	
	ASSUME ebx:PTR BOOKS
	ASSUME esi:PTR AUTHORS
	ASSUME edi:PTR CASES
	.if uMsg==WM_INITDIALOG
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		mov fAllowReg,FALSE
		invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
		invoke EnableWindow,eax,FALSE
		invoke GetDlgItem,hwnd,IDC_EDIT_RECT_TITLE
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_EDIT_RECT_AUTHOR1
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_EDIT_RECT_AUTHOR2
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_EDIT_RECT_AUTHOR3
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_LIST_RECT_AUTHOR
		mov hListRect,eax
		
		invoke GetDlgItem,hwnd,IDC_COMBO_RECT_CASE
		mov hCmbRect,eax
		invoke SendMessage,eax,CB_LIMITTEXT,39,0
		.if numBooks>0
			mov eax,numCases
			lea eax,[eax+eax*2]
			shl eax,4			;eax=size of cases
			invoke SendMessage,hCmbRect,CB_INITSTORAGE,numCases,eax
			mov eax,numAuthors
			lea eax,[eax+eax*2]
			shl eax,4			;eax=size of cases
			invoke SendMessage,hListRect,LB_INITSTORAGE,numAuthors,eax
			
		
			mov edi,pCases
			mov esi,pAuthors
			mov index,0
			LoadCmbRect:
				mov ecx,index
				lea ecx,[ecx+ecx*2]
				shl ecx,4
				push ecx
				invoke SendMessage,hCmbRect,CB_ADDSTRING,\
										0,addr [edi+ecx].szName
				pop ecx
				invoke SendMessage,hCmbRect,CB_SETITEMDATA,\
										eax,[edi+ecx].ID
				inc index
				mov eax,index
				cmp eax,numCases
				jb LoadCmbRect
		;-------------------------
			mov index,0
			LoadListRect:
				mov ecx,index
				lea ecx,[ecx+ecx*2]
				shl ecx,4
				push ecx
				invoke SendMessage,hListRect,LB_ADDSTRING,\
										0,addr [esi+ecx].szName
				pop ecx						
				invoke SendMessage,hListRect,LB_SETITEMDATA,\
										eax,[esi+ecx].ID
				inc index
				mov eax,index
				cmp eax,numAuthors
				jb LoadListRect
	
			xor ecx,ecx
			mov ebx,pBooks
			SearchBook:
				mov eax,bookID
				mov edx,ecx
				shl edx,6
				cmp [ebx+edx].ID,eax
				je findBook
				inc ecx
				cmp ecx,numBooks
				jb SearchBook
				
			findBook:
				mov bookOffset,edx
				mov eax,[ebx+edx].ID_C
				mov ID_C,eax
				mov eax,[ebx+edx].ID_A1
				mov ID_A1,eax
				mov eax,[ebx+edx].ID_A2
				mov ID_A2,eax
				mov eax,[ebx+edx].ID_A3
				mov ID_A3,eax
				invoke SetDlgItemText,hwnd,IDC_EDIT_RECT_TITLE,\
									addr [ebx+edx].szTitle
				
			xor ecx,ecx
			SearchCase:	
				mov eax,ID_C
				mov edx,ecx
				lea edx,[edx+edx*2]
				shl edx,4
				cmp [edi+edx].ID,eax
				je findCase
				inc ecx
				cmp ecx,numCases
				jb SearchCase
			jmp ToAuthor1	
			findCase:
				invoke SetDlgItemText,hwnd,IDC_COMBO_RECT_CASE,\
									addr [edi+edx].szName
			ToAuthor1:						
			xor ecx,ecx
			SearchAuthor1:						
				mov eax,ID_A1
				mov edx,ecx
				lea edx,[edx+edx*2]
				shl edx,4
				cmp [esi+edx].ID,eax
				je findAuthor1
				inc ecx
				cmp ecx,numAuthors
				jb SearchAuthor1
			jmp ToAuthor2
			findAuthor1:
				invoke SetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR1,\
									addr [esi+edx].szName
			ToAuthor2:						
			xor ecx,ecx
			SearchAuthor2:						
				mov eax,ID_A2
				mov edx,ecx
				lea edx,[edx+edx*2]
				shl edx,4
				cmp [esi+edx].ID,eax
				je findAuthor2
				inc ecx
				cmp ecx,numAuthors
				jb SearchAuthor2
			jmp ToAuthor3
			findAuthor2:
				invoke SetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR2,\
									addr [esi+edx].szName
			ToAuthor3:						
			xor ecx,ecx
			SearchAuthor3:						
				mov eax,ID_A3
				mov edx,ecx
				lea edx,[edx+edx*2]
				shl edx,4
				cmp [esi+edx].ID,eax
				je findAuthor3
				inc ecx
				cmp ecx,numAuthors
				jb SearchAuthor3
			jmp NoAuthor
			findAuthor3:
				invoke SetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR3,\
									addr [esi+edx].szName
			NoAuthor:						
		.endif
		invoke SetCursor,hCursor
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND	
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			.if ax==IDC_BUTTON_RECT_OK
				invoke EmptyBuffer,addr szTitle,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_TITLE,addr szTitle,40
				invoke ltrim,addr szTitle,addr szTitle
				invoke rtrim,addr szTitle,addr szTitle
				invoke lstrcmpi,addr szTitle,addr szZerro
				.if eax==0
					mov fAllowReg,FALSE
				.else
					mov fAllowReg,TRUE
				.endif
				invoke EmptyBuffer,addr szCase,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_RECT_CASE,\
										addr szCase,40
				invoke ltrim,addr szCase,addr szCase
				invoke rtrim,addr szCase,addr szCase
				invoke lstrcmpi,addr szCase,addr szZerro
				.if eax==0
					invoke MessageBox,hwnd,addr szCaseError,\
		               			addr szAppName,MB_OK or MB_ICONEXCLAMATION
					jmp exit
				.endif
				.if fAllowReg
					invoke LoadCursor,NULL, IDC_WAIT
					invoke SetCursor,eax
					mov hCursor,eax
					mov ebx,pBooks
					mov ecx,bookOffset
					invoke memCopy,addr [ebx+ecx].szTitle,\
										addr szTitle,40
				;--------Cases----------------------
					invoke SendMessage,hCmbRect,CB_FINDSTRINGEXACT,\
										-1,addr szCase
					.if eax ==CB_ERR
						invoke SendMessage,hCmbRect,CB_ADDSTRING,\
										0,addr szCase
						inc numCases
						invoke SendMessage,hCmbRect,CB_SETITEMDATA,\
												eax,numCases
						mov eax,numCases
						lea eax,[eax+eax*2]
						shl eax,4			;eax=size of cases
						invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
												pCases,eax
						.if eax==0
							invoke MessageBox,hwnd,addr szMemError,\
		               				addr szAppName,MB_OK or MB_ICONSTOP
							jmp exit
						.endif
						mov pCases,eax		;eax=new pCases
						mov ecx,numCases
						dec ecx
						lea ecx,[ecx+ecx*2]
						shl ecx,4
						mov edi,pCases
						mov eax,numCases
						mov [edi+ecx].ID,eax
						mov [edi+ecx].numBooks,1
						mov edx,bookOffset
						mov [ebx+edx].ID_C,eax
						invoke memCopy,addr [edi+ecx].szName,\
										addr szCase,40
					.else
						mov edi,pCases			;edi=pCases
						invoke SendMessage,hCmbRect,CB_SELECTSTRING,\
												-1,addr szCase
						invoke SendMessage,hCmbRect,CB_GETITEMDATA,eax,0
						mov ecx,bookOffset
						.if [ebx+ecx].ID_C==eax
							jmp authors
						.else
							mov newID,eax
							mov eax,[ebx+ecx].ID_C
							xor ecx,ecx
							CasesLoop1:
								mov edx,ecx
								lea edx,[edx+edx*2]
								shl edx,4
								cmp [edi+edx].ID,eax
								je exitCasesLoop1
								inc ecx
								cmp ecx,numCases
								jb CasesLoop1
							exitCasesLoop1:
						;-----------------------------	
							dec [edi+edx].numBooks
							.if [edi+edx].numBooks==0
								mov eax,ecx				;ecx=index
								inc eax					;eax=next index
								.if eax==numCases
									jmp noCopyCase
								.else
									mov edx,numCases
									sub edx,eax
									lea edx,[edx+edx*2]
									shl edx,4			;edx=size
									lea ecx,[ecx+ecx*2]
									shl ecx,4			;offset dest
									lea eax,[eax+eax*2]
									shl eax,4			;offset source
									add ecx,edi			;ecx=pDest
									add eax,edi			;eax=pSourse
									invoke memCopy,ecx,eax,edx
								.endif
								noCopyCase:
								dec numCases
								mov eax,numCases
								lea eax,[eax+eax*2]
								shl eax,4
								invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
															pCases,eax
								.if eax==0
									invoke MessageBox,hwnd,addr szMemError,\
		               						addr szAppName,MB_OK or MB_ICONSTOP
									jmp exit
								.endif
								mov pCases,eax		;eax=new pBooks
							.endif
							;-----------------
							mov eax,newID
							mov edi,pCases
							mov ecx,bookOffset
							mov [ebx+ecx].ID_C,eax
							xor ecx,ecx
							CasesLoop2:
								mov edx,ecx
								lea edx,[edx+edx*2]
								shl edx,4
								cmp [edi+edx].ID,eax
								je exitCasesLoop2
								inc ecx
								cmp ecx,numCases
								jb CasesLoop2
							exitCasesLoop2:
							inc [edi+edx].numBooks
						.endif	
					.endif
					authors:
				;----------Author1--------------
					invoke EmptyBuffer,addr szAuthor1,40
					invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR1,\
										addr szAuthor1,40
					invoke ltrim,addr szAuthor1,addr szAuthor1
					invoke rtrim,addr szAuthor1,addr szAuthor1
					invoke lstrcmpi,addr szAuthor1,addr szZerro
					.if eax==0
						mov ecx,bookOffset
						.if [ebx+ecx].ID_A1==0
							jmp author2
						.else
							mov eax,[ebx+ecx].ID_A1
							mov [ebx+ecx].ID_A1,0
							invoke RemoveAuBook,hwnd,eax
							.if eax
								mov pAuthors,eax
							.endif	
						.endif
					.else
						invoke SendMessage,hListRect,LB_FINDSTRINGEXACT,\
												-1,addr szAuthor1
						.if eax ==LB_ERR
							invoke AddAuthor,hwnd,addr szAuthor1,\
														addr ID
							mov pAuthors,eax					
							mov eax,ID
							mov ecx,bookOffset
							mov [ebx+ecx].ID_A1,eax
							invoke SendMessage,hListRect,\
									LB_ADDSTRING,0,addr szAuthor1
							invoke SendMessage,hListRect,\
									LB_SETITEMDATA,eax,ID
						.else
							invoke SendMessage,hListRect,LB_SELECTSTRING,\
												-1,addr szAuthor1
							mov esi,pAuthors			;esi=pAuthors
							invoke SendMessage,hListRect,LB_GETITEMDATA,eax,0
							invoke SetAuthor,eax
							mov ecx,bookOffset
							mov [ebx+ecx].ID_A1,eax
						.endif
					.endif
					author2:
					invoke EmptyBuffer,addr szAuthor2,40
					invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR2,\
										addr szAuthor2,40
					invoke ltrim,addr szAuthor2,addr szAuthor2
					invoke rtrim,addr szAuthor2,addr szAuthor2
					invoke lstrcmpi,addr szAuthor2,addr szZerro
					.if eax==0
						mov ecx,bookOffset
						.if [ebx+ecx].ID_A2==0
							jmp author3
						.else
							mov eax,[ebx+ecx].ID_A2
							mov [ebx+ecx].ID_A2,0
							invoke RemoveAuBook,hwnd,eax
							.if eax
								mov pAuthors,eax
							.endif	
						.endif
					.else
						invoke SendMessage,hListRect,LB_FINDSTRINGEXACT,\
												-1,addr szAuthor2
						.if eax ==LB_ERR
							invoke AddAuthor,hwnd,addr szAuthor2,\
														addr ID
							mov pAuthors,eax					
							mov eax,ID
							mov ecx,bookOffset
							mov [ebx+ecx].ID_A2,eax
							invoke SendMessage,hListRect,\
									LB_ADDSTRING,0,addr szAuthor2
							invoke SendMessage,hListRect,\
									LB_SETITEMDATA,eax,ID
						.else
							invoke SendMessage,hListRect,LB_SELECTSTRING,\
												-1,addr szAuthor2
							mov esi,pAuthors			;esi=pAuthors
							invoke SendMessage,hListRect,LB_GETITEMDATA,eax,0
							invoke SetAuthor,eax
							mov ecx,bookOffset
							mov [ebx+ecx].ID_A2,eax
							
						.endif
					.endif
					author3:
					invoke EmptyBuffer,addr szAuthor2,40
					invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR3,\
										addr szAuthor3,40
					invoke ltrim,addr szAuthor3,addr szAuthor3
					invoke rtrim,addr szAuthor3,addr szAuthor2
					invoke lstrcmpi,addr szAuthor3,addr szZerro
					.if eax==0
						mov ecx,bookOffset
						.if [ebx+ecx].ID_A3==0
							jmp noAuthor3
						.else
							mov eax,[ebx+ecx].ID_A3
							mov [ebx+ecx].ID_A3,eax
							invoke RemoveAuBook,hwnd,eax
							.if eax
								mov pAuthors,eax
							.endif	
						.endif
					.else
						invoke SendMessage,hListRect,LB_FINDSTRINGEXACT,\
												-1,addr szAuthor3
						.if eax ==LB_ERR
							invoke AddAuthor,hwnd,addr szAuthor3,\
														addr ID
							mov pAuthors,eax					
							mov eax,ID
							mov ecx,bookOffset
							mov [ebx+ecx].ID_A3,eax
							invoke SendMessage,hListRect,\
									LB_ADDSTRING,0,addr szAuthor3
							invoke SendMessage,hListRect,\
									LB_SETITEMDATA,eax,ID
						.else
							invoke SendMessage,hListRect,LB_SELECTSTRING,\
												-1,addr szAuthor3
							mov esi,pAuthors			;esi=pAuthors
							invoke SendMessage,hListRect,LB_GETITEMDATA,eax,0
							invoke SetAuthor,eax
							mov ecx,bookOffset
							mov [ebx+ecx].ID_A3,eax
						.endif
					.endif
					noAuthor3:
					mov fAllowReg,FALSE
					mov fFileChanged,TRUE
					mov fEditChanged,FALSE
					invoke SetCursor,hCursor
					invoke SendMessage,hToolbar,TB_ENABLEBUTTON,IDM_FILE_SAVE,TRUE
					invoke SendMessage,hChangesForm,WM_INITDIALOG,0,0
					invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
					invoke SendMessage,eax,WM_CLOSE,0,0
				.else
					invoke MessageBox,hwnd,addr szTitleError,\
		               			addr szAppName,MB_OK or MB_ICONEXCLAMATION
				.endif
        	;--------------------------------
			.elseif ax==IDC_BUTTON_RECT_CANCEL
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				invoke SendMessage,eax,WM_CLOSE,0,0
			.endif
        ;-------------------------------------------
		.elseif dx==EN_CHANGE
			.if ax==IDC_EDIT_RECT_TITLE
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
			.endif
			;--------------------------
			.if ax==IDC_EDIT_RECT_AUTHOR1
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
				invoke EmptyBuffer,addr szAuthor1,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR1,\
										addr szAuthor1,40
				invoke ltrim,addr szAuthor1,addr szAuthor1
				invoke SendMessage,hListRect,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor1
				.if eax !=LB_ERR
					invoke SendMessage,hListRect,LB_SELECTSTRING,\
											-1,addr szAuthor1
				.else
					invoke SendMessage,hListRect,LB_SETCURSEL,-1,0
				.endif
			.endif
			;--------------------------
			.if ax==IDC_EDIT_RECT_AUTHOR2
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
				invoke EmptyBuffer,addr szAuthor2,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR2,\
										addr szAuthor2,40
				invoke ltrim,addr szAuthor2,addr szAuthor2
				invoke SendMessage,hListRect,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor2
				.if eax !=LB_ERR
					invoke SendMessage,hListRect,LB_SELECTSTRING,\
											-1,addr szAuthor2
				.else
					invoke SendMessage,hListRect,LB_SETCURSEL,-1,0
				.endif
			.endif
			;--------------------------
			.if ax==IDC_EDIT_RECT_AUTHOR3
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
				invoke EmptyBuffer,addr szAuthor3,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_RECT_AUTHOR3,\
										addr szAuthor3,40
				invoke ltrim,addr szAuthor3,addr szAuthor3
				invoke SendMessage,hListRect,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor3
				.if eax !=LB_ERR
					invoke SendMessage,hListRect,LB_SELECTSTRING,\
											-1,addr szAuthor3
				.else
					invoke SendMessage,hListRect,LB_SETCURSEL,-1,0
				.endif
			.endif
		
        ;-------------------------------------------
		.elseif dx==CBN_SELENDOK
			.if ax==IDC_COMBO_RECT_CASE
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
			.endif
        ;-------------------------------------------
		.elseif dx==CBN_EDITUPDATE
			.if ax==IDC_COMBO_RECT_CASE
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
			
				invoke EmptyBuffer,addr szCase,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_RECT_CASE,\
											addr szCase,40
				invoke ltrim,addr szCase,addr szCase
				invoke SendMessage,hCmbRect,CB_FINDSTRINGEXACT,\
											-1,addr szCase
				.if eax !=CB_ERR
					invoke SendMessage,hCmbRect,CB_SELECTSTRING,\
											-1,addr szCase
				.endif
			.endif
        .endif
;-----------------------------------------------------------------
	.elseif uMsg==WM_PAINT        
		invoke GetDlgItem,hwnd,IDC_BUTTON_RECT_OK
		invoke EnableWindow,eax,FALSE
		mov fEditChanged,FALSE
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		mov fRectifyFormExist,FALSE
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ASSUME ebx:nothing
		ASSUME esi:nothing
		ASSUME edi:nothing
		pop edi
		pop esi
		pop ebx
		ret 
	.endif
	exit:
	ASSUME ebx:nothing
	ASSUME esi:nothing
	ASSUME edi:nothing
	pop edi
	pop esi
	pop ebx
	xor eax,eax
	ret
RectifyFormProc endp

