
.data

.data?
hCmbReg				dd ?
hListReg			dd ?

.code
RegFormProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL index		:DWORD
	LOCAL hCursor	:DWORD
	LOCAL ID		:DWORD
	push ebx
	push esi
	push edi
	
	ASSUME ebx:PTR BOOKS
;------------------------------------------------------------	
	.if uMsg==WM_INITDIALOG
		ASSUME esi:PTR AUTHORS
		ASSUME edi:PTR CASES
		invoke LoadCursor,NULL, IDC_WAIT
		invoke SetCursor,eax
		mov hCursor,eax
		mov fAllowReg,FALSE
		invoke GetDlgItem,hwnd,IDC_EDIT_REG_TITLE
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_EDIT_REG_AUTHOR1
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_EDIT_REG_AUTHOR2
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_EDIT_REG_AUTHOR3
		invoke SendMessage,eax,EM_LIMITTEXT,39,0
		
		invoke GetDlgItem,hwnd,IDC_LIST_REG_AUTHOR
		mov hListReg,eax
		
		invoke GetDlgItem,hwnd,IDC_COMBO_REG_CASE
		mov hCmbReg,eax
		invoke SendMessage,eax,CB_LIMITTEXT,39,0
		.if numBooks>0
			mov eax,numCases
			lea eax,[eax+eax*2]
			shl eax,4			;eax=size of cases
			invoke SendMessage,hCmbReg,CB_INITSTORAGE,numCases,eax
			mov eax,numAuthors
			lea eax,[eax+eax*2]
			shl eax,4			;eax=size of cases
			invoke SendMessage,hListReg,LB_INITSTORAGE,numAuthors,eax
		
			mov edi,pCases
			mov esi,pAuthors
			mov index,0
			LoadCmbReg:
				mov ecx,index
				lea ecx,[ecx+ecx*2]
				shl ecx,4
				push ecx
				invoke SendMessage,hCmbReg,CB_ADDSTRING,\
										0,addr [edi+ecx].szName
				pop ecx						
				invoke SendMessage,hCmbReg,CB_SETITEMDATA,\
										eax,[edi+ecx].ID
				inc index
				mov eax,index
				cmp eax,numCases
				jb LoadCmbReg
		;-------------------------
			mov index,0
			LoadListReg:
				mov ecx,index
				lea ecx,[ecx+ecx*2]
				shl ecx,4
				push ecx
				invoke SendMessage,hListReg,LB_ADDSTRING,\
										0,addr [esi+ecx].szName
				pop ecx						
				invoke SendMessage,hListReg,LB_SETITEMDATA,\
										eax,[esi+ecx].ID
				inc index
				mov eax,index
				cmp eax,numAuthors
				jb LoadListReg
		.endif
		invoke SetCursor,hCursor
		ASSUME esi:nothing
		ASSUME edi:nothing
;-----------------------------------------------------------------
	.elseif uMsg==WM_COMMAND	
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			;---------------------------------	
			.if ax==IDC_BUTTON_REG_NEWREG
				invoke SetDlgItemText,hwnd,IDC_EDIT_REG_TITLE,addr szZerro
				invoke SetDlgItemText,hwnd,IDC_COMBO_REG_CASE,addr szZerro
				invoke SetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR1,addr szZerro
				invoke SetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR2,addr szZerro
				invoke SetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR3,addr szZerro
				invoke GetDlgItem,hwnd,IDC_BUTTON_REG_APPLY
				invoke EnableWindow,eax,FALSE
				invoke GetDlgItem,hwnd,IDC_BUTTON_REG_OK
				invoke EnableWindow,eax,FALSE
				mov fEditChanged,FALSE
			
			;---------------------------------	
			.elseif ax==IDC_BUTTON_REG_APPLY
				.if fAllowReg
				;-------Books-----------
					invoke EmptyBuffer,addr szCase,40
					invoke GetDlgItemText,hwnd,IDC_COMBO_REG_CASE,\
										addr szCase,40
					invoke lstrcmpi,addr szCase,addr szZerro
					.if eax==0
						invoke MessageBox,hwnd,addr szCaseError,\
		               				addr szAppName,MB_OK or MB_ICONEXCLAMATION
		       ;        	mov fAllowReg,FALSE		
						jmp exit
					.endif
					invoke LoadCursor,NULL, IDC_WAIT
					invoke SetCursor,eax
					mov hCursor,eax
					inc numBooks
					mov eax,numBooks
					shl eax,6
					invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
											pBooks,eax
					.if eax==0
						invoke MessageBox,hwnd,addr szMemError,\
		               			addr szAppName,MB_OK or MB_ICONSTOP
		               	mov fAllowReg,FALSE		
						jmp exit
					.endif
					mov pBooks,eax		;eax=new pBooks
					mov ebx,eax			;ebx=pBooks
					mov eax,numBooks
					.if eax==1
						mov ecx,eax
						dec ecx
						shl ecx,6
						mov [ebx+ecx].ID,eax
					.elseif eax>1
						mov ecx,eax
						sub ecx,2
						shl ecx,6
						mov eax,[ebx+ecx].ID
						inc eax
						mov ecx,numBooks
						dec ecx
						shl ecx,6
						mov [ebx+ecx].ID,eax
					.endif
					invoke memCopy,addr [ebx+ecx].szTitle,addr szTitle,40
				;--------Cases--------
					ASSUME edi:PTR CASES
					invoke SendMessage,hCmbReg,CB_FINDSTRINGEXACT,\
										-1,addr szCase
					.if eax ==CB_ERR
						invoke SendMessage,hCmbReg,CB_ADDSTRING,\
										0,addr szCase
						inc numCases
						invoke SendMessage,hCmbReg,CB_SETITEMDATA,\
												eax,numCases
						mov eax,numCases
						lea eax,[eax+eax*2]
						shl eax,4			;eax=size of cases
						invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
												pCases,eax
						.if eax==0
							invoke MessageBox,hwnd,addr szMemError,\
		               				addr szAppName,MB_OK or MB_ICONSTOP
							dec numCases
							jmp exit
						.endif
						mov pCases,eax		;eax=new pCases
						mov edi,eax			;edi=pCases
						mov eax,numCases
						.if eax==1
							mov ecx,eax
							dec ecx
							lea ecx,[ecx+ecx*2]
							shl ecx,4
							mov [edi+ecx].ID,eax
						.elseif eax>1
							mov ecx,eax
							sub ecx,2
							lea ecx,[ecx+ecx*2]
							shl ecx,4
							mov eax,[edi+ecx].ID
							inc eax
							mov ecx,numCases
							dec ecx
							lea ecx,[ecx+ecx*2]
							shl ecx,4
							mov [edi+ecx].ID,eax
						.endif	
						mov [edi+ecx].numBooks,1
						mov edx,numBooks
						dec edx
						shl edx,6
						mov [ebx+edx].ID_C,eax
						invoke memCopy,addr [edi+ecx].szName,\
										addr szCase,40
					.else
						invoke SendMessage,hCmbReg,CB_SELECTSTRING,\
												-1,addr szCase
						mov edi,pCases			;edi=pCases
						invoke SendMessage,hCmbReg,CB_GETCURSEL,0,0
						invoke SendMessage,hCmbReg,CB_GETITEMDATA,eax,0
						mov ecx,numBooks
						dec ecx
						shl ecx,6
						mov [ebx+ecx].ID_C,eax
						xor ecx,ecx
						CasesLoop:
							mov edx,ecx
							lea edx,[edx+edx*2]
							shl edx,4
							cmp [edi+edx].ID,eax
							je exitCasesLoop
							inc ecx
							cmp ecx,numCases
							jb CasesLoop
						exitCasesLoop:
						inc [edi+edx].numBooks
					.endif
					authors:
					ASSUME edi:nothing
					ASSUME esi:PTR AUTHORS
				;----------Author1--------------
					invoke EmptyBuffer,addr szAuthor1,40
					invoke GetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR1,\
										addr szAuthor1,40
					invoke ltrim,addr szAuthor1,addr szAuthor1
					invoke rtrim,addr szAuthor1,addr szAuthor1
					invoke lstrcmpi,addr szAuthor1,addr szZerro
					cmp eax,0
					je noAuthor1
					invoke SendMessage,hListReg,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor1
					.if eax ==LB_ERR
						invoke AddAuthor,hwnd,addr szAuthor1,addr ID
						mov pAuthors,eax
						mov eax,ID
						mov edx,numBooks
						dec edx
						shl edx,6
						mov [ebx+edx].ID_A1,eax
						invoke SendMessage,hListReg,LB_ADDSTRING,\
										0,addr szAuthor1
						invoke SendMessage,hListReg,LB_SETITEMDATA,\
												eax,ID
					.else
						invoke SendMessage,hListReg,LB_SELECTSTRING,\
												-1,addr szAuthor1
						mov esi,pAuthors			;esi=pAuthors
						invoke SendMessage,hListReg,LB_GETITEMDATA,eax,0
						invoke SetAuthor,eax
						mov ecx,numBooks
						dec ecx
						shl ecx,6
						mov [ebx+ecx].ID_A1,eax
					.endif
					noAuthor1:
				;----------Author2--------------
					invoke EmptyBuffer,addr szAuthor2,40
					invoke GetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR2,\
										addr szAuthor2,40
					invoke ltrim,addr szAuthor2,addr szAuthor2
					invoke lstrcmpi,addr szAuthor2,addr szZerro
					cmp eax,0
					je noAuthor2
					invoke SendMessage,hListReg,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor2
					.if eax ==LB_ERR
						invoke AddAuthor,hwnd,addr szAuthor2,addr ID
						mov pAuthors,eax					
						mov eax,ID
						mov edx,numBooks
						dec edx
						shl edx,6
						mov [ebx+edx].ID_A2,eax
						invoke SendMessage,hListReg,LB_ADDSTRING,\
										0,addr szAuthor2
						invoke SendMessage,hListReg,LB_SETITEMDATA,\
												eax,ID
					.else
						invoke SendMessage,hListReg,LB_SELECTSTRING,\
												-1,addr szAuthor2
						mov esi,pAuthors			;esi=pAuthors
						invoke SendMessage,hListReg,LB_GETITEMDATA,eax,0
						invoke SetAuthor,eax
						mov ecx,numBooks
						dec ecx
						shl ecx,6
						mov [ebx+ecx].ID_A2,eax
					.endif
					noAuthor2:
				;----------Author3--------------
					invoke EmptyBuffer,addr szAuthor3,40
					invoke GetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR3,\
										addr szAuthor3,40
					invoke ltrim,addr szAuthor3,addr szAuthor3
					invoke lstrcmpi,addr szAuthor3,addr szZerro
					cmp eax,0
					je noAuthor3
					invoke SendMessage,hListReg,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor3
					.if eax ==LB_ERR
						invoke AddAuthor,hwnd,addr szAuthor3,addr ID						
						mov pAuthors,eax					
						mov eax,ID
						mov edx,numBooks
						dec edx
						shl edx,6
						mov [ebx+edx].ID_A3,eax
						invoke SendMessage,hListReg,LB_ADDSTRING,\
										0,addr szAuthor3
						invoke SendMessage,hListReg,LB_SETITEMDATA,\
												eax,ID
					.else
						invoke SendMessage,hListReg,LB_SELECTSTRING,\
												-1,addr szAuthor3
						mov esi,pAuthors			;esi=pAuthors
						invoke SendMessage,hListReg,LB_GETITEMDATA,eax,0
						invoke SetAuthor,eax
						mov ecx,numBooks
						dec ecx
						shl ecx,6
						mov [ebx+ecx].ID_A3,eax
					.endif
				
				noAuthor3:
					invoke GetDlgItem,hwnd,IDC_BUTTON_REG_NEWREG
					invoke EnableWindow,eax,TRUE
					invoke GetDlgItem,hwnd,IDC_BUTTON_REG_APPLY
					invoke EnableWindow,eax,FALSE
					invoke GetDlgItem,hwnd,IDC_BUTTON_REG_CANCEL
					invoke EnableWindow,eax,FALSE
				.else
					invoke MessageBox,hwnd,addr szTitleError,\
		               			addr szAppName,MB_OK or MB_ICONEXCLAMATION
				.endif
				ASSUME esi:PTR AUTHORS
				mov fAllowReg,FALSE
				mov fFileChanged,TRUE
				invoke SendMessage,hToolbar,TB_ENABLEBUTTON,IDM_FILE_SAVE,TRUE
				invoke SetCursor,hCursor
			;---------------------------------	
			.elseif ax==IDC_BUTTON_REG_OK
				.if fAllowReg
					MAKEDWORD IDC_BUTTON_REG_APPLY,BN_CLICKED
					invoke SendMessage,hwnd,WM_COMMAND,eax,0
				.endif
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				invoke SendMessage,eax,WM_CLOSE,0,0
			;---------------------------------	
			.elseif ax==IDC_BUTTON_REG_CANCEL
				invoke SendMessage,hClient,WM_MDIGETACTIVE,0,0
				invoke SendMessage,eax,WM_CLOSE,0,0
			.endif
        ;-------------------------------------------
		.elseif dx==EN_CHANGE
			.if ax==IDC_EDIT_REG_TITLE
				.if fEditChanged
					jmp exit
				.endif
				invoke GetDlgItem,hwnd,IDC_BUTTON_REG_APPLY
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_REG_OK
				invoke EnableWindow,eax,TRUE
				invoke GetDlgItem,hwnd,IDC_BUTTON_REG_NEWREG
				invoke EnableWindow,eax,FALSE
				invoke GetDlgItem,hwnd,IDC_BUTTON_REG_CANCEL
				invoke EnableWindow,eax,TRUE
				mov fEditChanged,TRUE
			.endif
			.if ax==IDC_EDIT_REG_AUTHOR1
				invoke EmptyBuffer,addr szAuthor1,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR1,\
										addr szAuthor1,40
				invoke ltrim,addr szAuthor1,addr szAuthor1
				invoke SendMessage,hListReg,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor1
				.if eax !=LB_ERR
					invoke SendMessage,hListReg,LB_SELECTSTRING,\
											-1,addr szAuthor1
				.else
					invoke SendMessage,hListReg,LB_SETCURSEL,-1,0
				.endif
			.endif
			.if ax==IDC_EDIT_REG_AUTHOR2
				invoke EmptyBuffer,addr szAuthor2,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR2,\
										addr szAuthor2,40
				invoke ltrim,addr szAuthor2,addr szAuthor2
				invoke SendMessage,hListReg,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor2
				.if eax !=LB_ERR
					invoke SendMessage,hListReg,LB_SELECTSTRING,\
											-1,addr szAuthor2
				.else
					invoke SendMessage,hListReg,LB_SETCURSEL,-1,0
				.endif
			.endif
			.if ax==IDC_EDIT_REG_AUTHOR3
				invoke EmptyBuffer,addr szAuthor3,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_REG_AUTHOR3,\
										addr szAuthor3,40
				invoke ltrim,addr szAuthor3,addr szAuthor3
				invoke SendMessage,hListReg,LB_FINDSTRINGEXACT,\
										-1,addr szAuthor3
				.if eax !=LB_ERR
					invoke SendMessage,hListReg,LB_SELECTSTRING,\
											-1,addr szAuthor3
				.else
					invoke SendMessage,hListReg,LB_SETCURSEL,-1,0
				.endif
			.endif
        ;-------------------------------------------
		.elseif dx==EN_KILLFOCUS
			.if ax==IDC_EDIT_REG_TITLE
				invoke EmptyBuffer,addr szTitle,40
				invoke GetDlgItemText,hwnd,IDC_EDIT_REG_TITLE,addr szTitle,40
				invoke ltrim,addr szTitle,addr szTitle
				invoke rtrim,addr szTitle,addr szTitle
				invoke lstrcmpi,addr szTitle,addr szZerro
				.if eax==0
					mov fAllowReg,FALSE
				.else
					mov fAllowReg,TRUE
				.endif
			.endif
        ;-------------------------------------------
		.elseif dx==CBN_EDITUPDATE
			.if ax==IDC_COMBO_REG_CASE
				invoke EmptyBuffer,addr szCase,40
				invoke GetDlgItemText,hwnd,IDC_COMBO_REG_CASE,\
											addr szCase,40
				invoke ltrim,addr szCase,addr szCase
				invoke rtrim,addr szCase,addr szCase
				invoke SendMessage,hCmbReg,CB_FINDSTRINGEXACT,\
											-1,addr szCase
				.if eax !=CB_ERR
					invoke SendMessage,hCmbReg,CB_SELECTSTRING,\
											-1,addr szCase
				.endif
			.endif	
        ;-------------------------------------------
			
		.endif
;-----------------------------------------------------------------
	.elseif uMsg==WM_PAINT        
		invoke GetDlgItem,hwnd,IDC_BUTTON_REG_OK
		invoke EnableWindow,eax,FALSE
		mov fEditChanged,FALSE
;-----------------------------------------------------------------
	.elseif uMsg==WM_DESTROY
		mov fRegFormExist,FALSE
;-----------------------------------------------------------------
	.else 	
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		ASSUME ebx:nothing
		ASSUME esi:nothing
		ASSUME edi:nothing
		pop edi
		pop esi
		pop ebx
		ret 
	.endif
	exit:
	ASSUME ebx:nothing
	ASSUME esi:nothing
	ASSUME edi:nothing
	pop edi
	pop esi
	pop ebx
	xor eax,eax
	ret
RegFormProc endp
